
{*-------------------------------------------------------------------------------*}
{* VerSionPro for PengWin -- a version info manager for the mere mortals         *}
{*	(penguins included)                                                          *}
{* 	Copyright (c) Dinh DOAN VAN BIEN																						 *}
{* 	May be used by everybody for any purpose, provided that:                     *}
{*		- My copyright stuff is not removed                                        *}
{*    - Distribution of this package or of packages derived from it includes     *}
{*		  source code as well as the executables                                   *}
{*    - You send me your additions (no binaries, source code only)               *}
{*    - This package is not selled to make undue profit on my hard pengwin work  *}
{*    - etc.                                                                     *}
{*  In fact I'd like to distribute this package under the GNU License but I      *}
{*  don't know how to do that, so if someone can give me a clue, drop me a mail  *}
{*  I can be reached at "dihn@msn.com".                                          *}
{*-------------------------------------------------------------------------------*}

unit Childwin;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls, Menus;

type
	TThings = class;

  TMDIChild = class(TForm)
    PageControl: TPageControl;
    TabGeneral: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    TabType: TTabSheet;
    DRV_SUB: TRadioGroup;
    FNT_SUB: TRadioGroup;
    Label3: TLabel;
    VXD_SUB: TEdit;
    TabLang: TTabSheet;
    FILEFLAGS: TGroupBox;
    FILEFLAGS0: TCheckBox;
    FILEFLAGS1: TCheckBox;
    FILEFLAGS2: TCheckBox;
    FILEFLAGS3: TCheckBox;
    FILEFLAGS4: TCheckBox;
    ListLang: TListBox;
    GroupBox2: TGroupBox;
    ChooseLang: TComboBox;
    Label4: TLabel;
    ChooseCharset: TComboBox;
    Label5: TLabel;
    TabStringInfo: TTabSheet;
    SelLang: TComboBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Comments: TEdit;
    CompanyName: TEdit;
    FileDescription: TEdit;
    FileVersion: TEdit;
    InternalName: TEdit;
    LegalCopyright: TEdit;
    LegalTradeMark: TEdit;
    OriginalFileName: TEdit;
    PrivateBuild: TEdit;
    ProductVersion: TEdit;
    SpecialBuild: TEdit;
    FILEVERSION1: TEdit;
    FILEVERSION2: TEdit;
    FILEVERSION3: TEdit;
    FILEVERSION4: TEdit;
    PRODUCTVERSION1: TEdit;
    PRODUCTVERSION2: TEdit;
    PRODUCTVERSION3: TEdit;
    PRODUCTVERSION4: TEdit;
    FILETYPE: TRadioGroup;
    Label18: TLabel;
    bRemLang: TBitBtn;
    bAddLang: TBitBtn;
    FILEOS: TRadioGroup;
    FILEGUI: TRadioGroup;
    SaveDialog: TSaveDialog;
    procedure FILEFLAGSClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure bAddLangClick(Sender: TObject);
    procedure StringControlsChange(Sender: TObject);
    procedure bRemLangClick(Sender: TObject);
    procedure TabStringInfoEnter(Sender: TObject);
    procedure SelLangChange(Sender: TObject);
    procedure FILETYPEClick(Sender: TObject);
    procedure GenericChange(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure PageControlChange(Sender: TObject);
  private
    { Dclarations prives }

		FFlags: Integer;	// Mirror value of the FILEFLAGS checkboxes
	  Lang: TThings;		// Indexed list of languages for this window
  	CurLang, OldLang: Integer;	// Track the language being edited
	  StringInfoStat: Word;	// Bitfield to track changes to the StringInfo controls

    Modified: Boolean;		// True if the file was modified
    IsExec: Boolean;			// True if we're editing an exe
    NoCloseQuery: Boolean; // True if we panic after an error
    VerFileName: String;	// Hold the current file name

    procedure UpdateStringInfo;
		procedure ClearStringControls;
		procedure LoadStringControls(LangIndex: Integer);

    function AddLanguage(l, c: Integer): Pointer;
    function IndexToLang(index: Integer; var l, c: Integer): Boolean;

		function IgnoreModifications(Title: PChar): Boolean;

    procedure RestoreFFlags(const s: String);
    procedure RestoreFOs(const s1, s2: String);
    procedure RestoreFType(const s1, s2: String);
    procedure DumpVersionInfo(Dest: TStrings);
    procedure ParseVersionInfo(const SrcName: String; Src: TStrings);
		procedure DumpToFile;

    procedure DestroyInfo(Sender: TObject; Thing: Pointer);
    	// Event handler for the Lang TThings instance

  public
    { Dclarations publiques }
    procedure CopyToClipboard;
    procedure PasteFromClipboard;
    procedure LoadFromFile(const FName: String);
    procedure SaveToFile;
    procedure SaveAsFile;
    	// And Bjorg Stronginthearm is you uncle.
  end;

  {* A primitive but useful indexed list *}

  TThingDestroyer = procedure (Sender: TObject; Thing: Pointer) of object;

  TThings = class
  private
  	FIndexs: TList;
  	FThings: TList;
    FOnDestroy: TThingDestroyer;
    function GetCount: Integer;
  	function GetThings(Index: Integer): Pointer;
		procedure SetThings(Index: Integer; Thing: Pointer);
  public
  	constructor Create(OnDestroyFunc: TThingDestroyer);
    destructor Destroy; override;
    procedure Clear;
    procedure Delete(Index: Integer);
    function IndexExists(Index: Integer): Boolean;
    procedure Add(Index: Integer; Thing: Pointer);
		property Things[Index: Integer]: Pointer
    	read GetThings write SetThings;
    property Count: Integer
    	read GetCount;
    property OnDestroy: TThingDestroyer
    	read FOnDestroy write FOnDestroy;
  end;

var
  MDIChild: TMDIChild;

////////////////////////////////////////////////////////////////////////////////
// Template used to create blank files' names, shared with Main
//
const
	FTM_UNTITLED = 'Version %d';

implementation

uses ClipBrd;

////////////////////////////////////////////////////////////////////////////////
// Localizable string constants
//
const
	MSG_INVALID_FILE = 'No VS_VERSIONINFO entry found in the %s';
  FMT_TEXT_FILE = 'file "%s"';
  FMT_EXEC_FILE = 'executable binary file "%s"';
  FMT_CLIPBOARD = 'clipboard';

	MSG_MODIFIED_PROMPT =
  	'This file was modified.' + #13 + #10 +
    'Do you really want to go on and lose your changes?';

  TTL_PASTE = 'Paste from the clipboard';
  TTL_FMT_CLOSE = 'Close %s';

////////////////////////////////////////////////////////////////////////////////
// Constants used by file managment functions
//
const
	START_MAGIC = '//##APPVER##';	// Start of app generated info
  END_MAGIC = '//##END##';			// End of app generated info

  REC1_COUNT = 13; // 4 FV, 4 PV, FFlags,	FType, FSubType, Os, Gui
  REC2_COUNT = 2; // index, nb of entries
  REC3_COUNT = 2; // item, string

////////////////////////////////////////////////////////////////////////////////
// Structure to store version info strings
//
const
	MAX_STRINGINFO = 10;

type
  TStringInfo = array [0..MAX_STRINGINFO] of String;
  PStringInfo = ^TStringInfo;

////////////////////////////////////////////////////////////////////////////////
// Language stuff
//
	TLangInfo = packed record	// It's really a LongInt
  	CharSet, Lang: Word;
	end;

	TLangRec = record
		v: Integer;
		s: String;
	end;

////////////////////////////////////////////////////////////////////////////////
// Arrays used to map the control tags
//
const
	LANGLIST: array [0..44] of TLangRec = ( // I used AWK to make this one
		(v:$0401; s:'Arabic'),
		(v:$0402; s:'Bulgarian'),
		(v:$0403; s:'Catalan'),
		(v:$0404; s:'Traditional Chinese'),
		(v:$0804; s:'Simplified Chinese'),
		(v:$0405; s:'Czech'),
		(v:$0406; s:'Danish'),
		(v:$0407; s:'German'),
		(v:$0807; s:'Swiss German'),
		(v:$0408; s:'Greek'),
		(v:$0409; s:'U.S. English'),
		(v:$0809; s:'U.K. English'),
		(v:$040A; s:'Castilian Spanish'),
		(v:$080A; s:'Mexican Spanish'),
		(v:$040B; s:'Finnish'),
		(v:$040C; s:'French'),
		(v:$080C; s:'Belgian French'),
		(v:$0C0C; s:'Canadian French'),
		(v:$100C; s:'Swiss French'),
		(v:$040D; s:'Hebrew'),
		(v:$040E; s:'Hungarian'),
		(v:$040F; s:'Icelandic'),
		(v:$0410; s:'Italian'),
		(v:$0810; s:'Swiss Italian'),
		(v:$0411; s:'Japanese'),
		(v:$0412; s:'Korean'),
		(v:$0413; s:'Dutch'),
		(v:$0813; s:'Belgian Dutch'),
		(v:$0414; s:'Norwegian - Bokml'),
		(v:$0814; s:'Norwegian - Nynorsk'),
		(v:$0415; s:'Polish'),
		(v:$0416; s:'Brazilian Portuguese'),
		(v:$0816; s:'Portuguese'),
		(v:$0417; s:'Rhaeto-Romanic'),
		(v:$0418; s:'Romanian'),
		(v:$0419; s:'Russian'),
		(v:$041A; s:'Croato-Serbian (Latin)'),
		(v:$081A; s:'Serbo-Croatian (Cyrillic)'),
		(v:$041B; s:'Slovak'),
		(v:$041C; s:'Albanian'),
		(v:$041D; s:'Swedish'),
		(v:$041E; s:'Thai'),
		(v:$041F; s:'Turkish'),
		(v:$0420; s:'Urdu'),
		(v:$0421; s:'Bahasa')
	);

	CHARSETLIST: array [0..11] of TLangRec = (
		(v:0; s:'7-bit ASCII'),
		(v:932; s:'Windows, Japan (Shift - JIS X-0208)'),
		(v:949; s:'Windows, Korea (Shift - KSC 5601)'),
		(v:950; s:'Windows, Taiwan (GB5)'),
		(v:1200; s:'Unicode'),
		(v:1250; s:'Windows, Latin-2 (Eastern European)'),
		(v:1251; s:'Windows, Cyrillic'),
		(v:1252; s:'Windows, Multilingual (ANSI)'),
		(v:1253; s:'Windows, Greek'),
		(v:1254; s:'Windows, Turkish'),
		(v:1255; s:'Windows, Hebrew'),
		(v:1256; s:'Windows, Arabic')
	);

  MAP_FILEFLAGS: array [0..4] of Integer = (
		VS_FF_DEBUG,
		VS_FF_PATCHED,
		VS_FF_PRERELEASE,
		VS_FF_PRIVATEBUILD,
		VS_FF_SPECIALBUILD
  );

  MAP_OS: array [0..3] of Integer = (
  	VOS_DOS,
  	VOS_OS216,
  	VOS_OS232,
    VOS_NT
  );

  MAP_GUI: array [0..3] of Integer = (
    VOS__PM16,
    VOS__PM32,
    VOS__WINDOWS16,
    VOS__WINDOWS32
  );

  OS_MASK 	= $F0000;
  GUI_MASK 	= $0000F;

  MAP_FILETYPE: array [0..5] of Integer = (
		VFT_APP,
		VFT_DLL,
		VFT_DRV,
		VFT_FONT,
		VFT_VXD,
		VFT_STATIC_LIB
  );

  MAP_DRVSUBTYPE: array [0..8] of Integer = (
		VFT2_DRV_PRINTER,
		VFT2_DRV_KEYBOARD,
		VFT2_DRV_LANGUAGE,
		VFT2_DRV_DISPLAY,
		VFT2_DRV_MOUSE,
		VFT2_DRV_NETWORK,
		VFT2_DRV_SYSTEM,
		VFT2_DRV_INSTALLABLE,
		VFT2_DRV_SOUND
  );

  MAP_FNTSUBTYPE: array [0..2] of Integer = (
		VFT2_FONT_RASTER,
		VFT2_FONT_VECTOR,
		VFT2_FONT_TRUETYPE
  );

	MAP_STRINGINFO: TStringInfo = (
   'Comments',
   'CompanyName',
   'FileDescription',
   'FileVersion',
   'InternalName',
   'LegalCopyright',
   'LegalTradeMark',
   'OriginalFileName',
   'PrivateBuild',
   'ProductVersion',
   'SpecialBuild'
	);

{$R *.DFM}

{* Utility functions *}

////////////////////////////////////////////////////////////////////////////////
// MapIntArray
// 	Lookup the value "V" in the array "Map" and return its index.
//
//	Return -1 if "V" was not found.
//
function MapIntArray(V: Integer; const Map: array of Integer): Integer;
var
  i: Integer;
begin
  Result := -1;
  for i := 0 to High(Map) do
    if V = Map[i] then
    begin
      Result := i;
      Break;
    end;
end;

{* TThings Class *}

////////////////////////////////////////////////////////////////////////////////
// TThings
// 	This class implements a very basic double-entry list with auto-free feature
//	(throug the OnDestroy event).
//
constructor TThings.Create(OnDestroyFunc: TThingDestroyer);
begin
  FThings := TList.Create;
  FIndexs := TList.Create;
  FOnDestroy := OnDestroyFunc;
end;

destructor TThings.Destroy;
begin
	Clear;
  FIndexs.Free;
  FThings.Free;
end;

procedure TThings.Add(Index: Integer; Thing: Pointer);
begin
  FIndexs.Add(Pointer(Index));
  FThings.Add(Thing);
end;

procedure TThings.Clear;
var
	i: Integer;
begin
	FIndexs.Clear;
  if Assigned(FOnDestroy) then
	  for i := 0 to FThings.Count - 1 do
  		FOnDestroy(Self, FThings.Items[i]);
  FThings.Clear;
end;

procedure TThings.Delete(Index: Integer);
var
	i: Integer;
begin
	i := FIndexs.Remove(Pointer(Index));
  if i <> -1 then
  begin
    if Assigned(FOnDestroy) then
      FOnDestroy(Self, FThings.Items[i]);
    FThings.Delete(i);
  end;
end;

function TThings.IndexExists(Index: Integer): Boolean;
begin
  Result := FIndexs.IndexOf(Pointer(Index)) >= 0;
end;

function TThings.GetCount: Integer;
begin
	Result := FIndexs.Count;
end;

function TThings.GetThings(Index: Integer): Pointer;
begin
  Result := FThings.Items[FIndexs.IndexOf(Pointer(Index))];
end;

procedure TThings.SetThings(Index: Integer; Thing: Pointer);
begin
  FThings.Items[FIndexs.IndexOf(Pointer(Index))] := Thing;
end;

{* TCBStrings Class *}

////////////////////////////////////////////////////////////////////////////////
// TCBStrings
// 	A TStringList with Clipoard Copy/Paste methods.
//
type
	TCBStrings = class(TStringList)
  public
  	procedure CopyToClipboard;
    procedure PasteFromClipboard;
  end;

procedure TCBStrings.CopyToClipboard;
var
	s: String;
  CB: TClipBoard;
begin
	CB := ClipBoard;
  s := Text;
  if s <> '' then
  	CB.AsText := s
  else
  	CB.Clear;
end;

procedure TCBStrings.PasteFromClipboard;
var
  CB: TClipBoard;
begin
	CB := ClipBoard;
  Text := CB.AsText;
end;

{* TMDIChild *}

{* TMDIChild Dump/Restore funcs *}

////////////////////////////////////////////////////////////////////////////////
// RestoreFFlags
// 	Update the value of the FILEFLAGSx controls using the "s" numeric
//	representation.
//
procedure TMDIChild.RestoreFFlags(const s: String);
var
	i: Integer;
begin
	FFlags := StrToIntDef(s, 0);
	for i := 0 to High(MAP_FILEFLAGS) do
  	with FindComponent(Format('FILEFLAGS%d', [i])) as TCheckBox do
  		Checked := (FFlags and MAP_FILEFLAGS[i]) <> 0;
end;

////////////////////////////////////////////////////////////////////////////////
// RestoreFFlags
// 	Update the value of the FILEOS and FILEGUI controls using the "s1" and "s2"
//	numeric	representation.
//	"s1" is a valid index in the FILEOS RadioGroup.
//	"s2" is a valid index in the FILEGUI RadioGroup.
//
procedure TMDIChild.RestoreFOs(const s1, s2: String);
begin
	FILEOS.ItemIndex := StrToIntDef(s1, -1);
  FILEGUI.ItemIndex := StrToIntDef(s2, -1);
end;

////////////////////////////////////////////////////////////////////////////////
// RestoreFType
// 	Update the value of the FILETYPE and XXX_SUB controls using the "s1" and "s2"
//	numeric	representation.
//	"s1" is a valid index in the FILETYPE RadioGroup.
//	"s2" is a valid index in
//		the DRV_SUB RadioGroup if s1 = "2"
//		the FNT_SUB RadioGroup if s1 = "3"
//  a numeric value for the VXD_SUB Edit control if s1 = "4"
//
procedure TMDIChild.RestoreFType(const s1, s2: String);
var
	FType: Integer;
begin
  DRV_SUB.ItemIndex := -1;
  FNT_SUB.ItemIndex := -1;
  VXD_SUB.Text := '';

  FType := StrToIntDef(s1, -1);
  case FType of
  2:
  	DRV_SUB.ItemIndex := StrToIntDef(s2, -1);
  3:
  	FNT_SUB.ItemIndex := StrToIntDef(s2, -1);
  4:
  	VXD_SUB.Text := s2;
  end;

  FILETYPE.ItemIndex := FType;
  FILETYPEClick(FILETYPE);
end;

////////////////////////////////////////////////////////////////////////////////
// IndexToLang
//	Map an integer value to indexes in LANGLIST ("l") and CHARSETLIST ("c").
//
function TMDIChild.IndexToLang(index: Integer; var l, c: Integer): Boolean;
var
  i: Integer;
begin
  l := -1; c := -1;
  for i := 0 to High(LANGLIST) do
    if LANGLIST[i].v = TLangInfo(index).Lang then
    begin
      l := i;
      Break;
    end;

  for i := 0 to High(CHARSETLIST) do
    if CHARSETLIST[i].v = TLangInfo(index).CharSet then
    begin
      c := i;
      Break;
    end;

  Result := (l >= 0) and (c >= 0);
end;

////////////////////////////////////////////////////////////////////////////////
// ParseVersionInfo  = BIG AND UGLY HACK
//	Restore the version information from textual representation stored
//	in the string list "Src".
//	"SrcName" is string describing the origin of the contents of Src
//	(i.e. "file %s" or "clipboard"...).
//
//	Raise an exception is the string list doen't contain a valid version
//  information description.
//
procedure TMDIChild.ParseVersionInfo(const SrcName: String; Src: TStrings);

var
	i, k, nb: Integer;
  Tmp: TStrings;
  s: String;
  hadError: Boolean;
  rec1: array [1..REC1_COUNT] of String;
	l, c: Integer;
  info: PStringInfo;

begin
	i := Src.IndexOf(START_MAGIC);
  if i >= 0 then
  begin
  	Tmp := TStringList.Create;
    try
    	Inc(i);
      s := Src[i];
      Delete(s, 1, 2);
      Tmp.CommaText := s;
      if Tmp.Count = REC1_COUNT then
      begin
      	for k := 1 to REC1_COUNT do
        	rec1[k] := Tmp[k - 1];

        k := i;
        hadError := False;
        while not hadError do
        begin
        	if k < Src.Count - 1 then
          begin
            Inc(k);
            s := Src[k];

            if s = END_MAGIC then
            	Break;

            Delete(s, 1, 2);
            Tmp.CommaText := s;

            if Tmp.Count = REC2_COUNT then
            begin
            	nb := StrToIntDef(Tmp[0], 0);
            	if IndexToLang(nb, l, c) then
              begin
                nb := StrToIntDef(Tmp[1], 0);
                if nb > 0 then
                begin
                  repeat
                    Inc(k);
                    s := Src[k];
                    Delete(s, 1, 2);
                    Tmp.CommaText := s;
                    if Tmp.Count <> REC3_COUNT then Break;
                    Dec(nb);
                  until nb = 0;
                  if nb = 0 then
                    Continue;
                end
              end
            end
        	end;
          hadError := True;
        end;

        if not hadError then
        begin
					FILEVERSION1.Text := rec1[1];
          FILEVERSION2.Text := rec1[2];
          FILEVERSION3.Text := rec1[3];
          FILEVERSION4.Text := rec1[4];

					PRODUCTVERSION1.Text := rec1[5];
          PRODUCTVERSION2.Text := rec1[6];
          PRODUCTVERSION3.Text := rec1[7];
          PRODUCTVERSION4.Text := rec1[8];

					RestoreFFlags(rec1[9]);
          RestoreFType(rec1[10], rec1[11]);
          RestoreFOs(rec1[12], rec1[13]);


          SelLang.Items.Clear;
			    SelLangChange(SelLang);
          Lang.Clear;
          ListLang.Items.Clear;

          repeat
            Inc(i);
            s := Src[i];

            if s = END_MAGIC then
            	Break;

            Delete(s, 1, 2);
            Tmp.CommaText := s;

            IndexToLang(StrToIntDef(Tmp[0], 0), l, c);
            info := AddLanguage(l, c);

            if not Assigned(info) then
            	raise Exception.Create('Assertion failed: info = nil');

            nb := StrToIntDef(Tmp[1], 0);
            for k := 1 to nb do
            begin
              Inc(i);
              s := Src[i];
              Delete(s, 1, 2);
              Tmp.CommaText := s;
              info^[StrToIntDef(Tmp[0], 0)] := Tmp[1];
            end;
          until i >= Src.Count - 1;

					Exit; // will go through the finally blocks

        end; //if not hadError

      end; //if Tmp.Count = REC1_COUNT

    finally
    	Tmp.Free;
    end;
  end;

//-- We fail here only if an error ocurred
  raise Exception.CreateFmt(MSG_INVALID_FILE, [SrcName]);
end;

////////////////////////////////////////////////////////////////////////////////
// DumpVersionInfo = BIG AND UGLY HACK
//	Compute a textual representation of the current version information
//	and place the result in the string list "Dest".
//
procedure TMDIChild.DumpVersionInfo(Dest: TStrings);

const
	SEP = '//--------------------------------------------------------------------';
  SP2 = '  ';
  SP4 = SP2 + SP2;
  SP6 = SP4 + SP2;
  SZ: array [False..True] of String = ('\0', '');

var
	Tmp: TStrings;

	FVStr, PVStr: String;
	FOs: Integer;
  FType: Integer;
  FSubType, FTmpSubType: String;

  comma: String;
  info: PStringInfo;
  i, j, index, maxLang, nbItems: Integer;

	function HasNULL(const s: String): Boolean;
  begin
  	Result := (s[Length(s) - 1] = '\') and (s[Length(s)] = '0');
  end;

  procedure ComputeParams;
  begin
  	FVStr := Format('%s,%s,%s,%s',
    	[FILEVERSION1.Text, FILEVERSION2.Text, FILEVERSION3.Text, FILEVERSION4.Text]
    );

    PVStr := Format('%s,%s,%s,%s',
      [PRODUCTVERSION1.Text, PRODUCTVERSION2.Text, PRODUCTVERSION3.Text, PRODUCTVERSION4.Text]
    );

    FType := 0;
    if FILETYPE.ItemIndex >= 0 then
      FType := MAP_FILETYPE[FILETYPE.ItemIndex];

    FSubType := '';
    FTmpSubType := '0';
    case FILETYPE.ItemIndex of
    2:
      if DRV_SUB.ItemIndex >= 0 then
      begin
        FSubType := IntToStr(MAP_DRVSUBTYPE[DRV_SUB.ItemIndex]);
        FTmpSubType := IntToStr(DRV_SUB.ItemIndex);
      end;
    3:
      if FNT_SUB.ItemIndex >= 0 then
      begin
        FSubType := IntToStr(MAP_FNTSUBTYPE[FNT_SUB.ItemIndex]);
        FTmpSubType := IntToStr(FNT_SUB.ItemIndex);
      end;
    4:
      begin
        FSubType := VXD_SUB.Text;
        FTmpSubType := FSubType;
      end;
    end;

    FOs := 0;

    if FILEOS.ItemIndex >= 0 then
      FOs := FOs or MAP_OS[FILEOS.ItemIndex];

    if FILEGUI.ItemIndex >= 0 then
      FOs := FOs or MAP_GUI[FILEGUI.ItemIndex];
  end;

begin

//-- Make sure the information is up to date
	UpdateStringInfo;

	Dest.BeginUpdate;
  try
  	Tmp := TStringList.Create;
    try
    //-- FIXED INFO
      Dest.Add('1 VERSIONINFO');

      ComputeParams;

      Dest.Add(Format('FILEVERSION %s', [FVStr]));

      Dest.Add(Format('PRODUCTVERSION %s', [PVStr]));

      Dest.Add(Format('FILEFLAGSMASK 0x%.8x', [VS_FFI_FILEFLAGSMASK]));
      Dest.Add(Format('FILEFLAGS 0x%.8x', [FFlags]));

      Dest.Add(Format('FILETYPE 0x%.8x', [FType]));

      if FSubType <> '' then
        Dest.Add(Format('FILESUBTYPE %s', [FSubType]));

      Dest.Add(Format('FILEOS 0x%.8x', [FOs]));

      Tmp.Add(Format('//%s,%s,$%x,$%x,%s,%d,%d', [
      	FVStr, PVStr,	FFlags,	FILETYPE.ItemIndex, FTmpSubType,
        FILEOS.ItemIndex, FILEGUI.ItemIndex
      ]));

    //-- BEGIN
      Dest.Add('BEGIN');

    //-- This value will be used in the 2 following loops
      maxLang := ListLang.Items.Count - 1;

    //-- StringInfo
      Dest.Add(SP2 + 'BLOCK "StringFileInfo"');
      Dest.Add(SP2 + 'BEGIN');
      for i := 0 to maxLang do
      begin
        index := Integer(ListLang.Items.Objects[i]);
        info := Lang.Things[index];

        Dest.Add(Format(SP4 + 'BLOCK "%.4x%.4x"', [TLangInfo(index).Lang, TLangInfo(index).CharSet]));
        Dest.Add(SP4 + 'BEGIN');

        nbItems := 0;
        for j := 0 to MAX_STRINGINFO do
          if info^[j] <> '' then
          begin
            Dest.Add(Format(SP6 + 'VALUE "%s", "%s%s"', [
              MAP_STRINGINFO[j], info^[j], SZ[HasNULL(info^[j])]
            ]));
            Inc(nbItems);
          end;

        Dest.Add(SP4 + 'END');

        Tmp.Add(Format('//$%x,%d', [index, nbItems]));
        for j := 0 to MAX_STRINGINFO do
          if info^[j] <> '' then
          	Tmp.Add(Format('//%d,"%s%s"', [
            	j, info^[j], SZ[HasNULL(info^[j])]
            ]));
      end;

      Dest.Add(SP2 + 'END');

    //-- VarFileInfo
      Dest.Add(SP2 + 'BLOCK "VarFileInfo"');
      Dest.Add(SP2 + 'BEGIN');
      Dest.Add(SP4 + 'VALUE "Translation",');

      comma := ',';

      for i := 0 to maxLang do
      begin
        if i = maxLang then	comma := '';
        index := Integer(ListLang.Items.Objects[i]);
        Dest.Add(Format(SP6 + '0x%.4x, %d%s', [
          TLangInfo(index).Lang, TLangInfo(index).CharSet, comma
        ]));
      end;

      Dest.Add(SP2 + 'END');

    //-- END

      Dest.Add('END');

    //-- Auto info
      Dest.Add(SEP);
      Dest.Add('//Automatically generated info *DO NOT EDIT*');
      Dest.Add(START_MAGIC);
      Dest.AddStrings(Tmp);
      Dest.Add(END_MAGIC);

    finally
    	Tmp.Free;
    end;
  finally
  	Dest.EndUpdate;
  end;
end;

{* TMDIChild File/Edit Menu items *}

////////////////////////////////////////////////////////////////////////////////
// IgnoreModifications
// 	Ask confirmation from the user before closing or overwriting a modified
//  file.
//
//  Return True if it's OK to ignore the current modifications.
//
function TMDIChild.IgnoreModifications(Title: PChar): Boolean;
const
	MB_FLAGS = MB_ICONQUESTION or MB_YESNO or MB_DEFBUTTON2;
begin
	Result := not Modified or (Application.MessageBox(MSG_MODIFIED_PROMPT, Title, MB_FLAGS) = IDYES);
end;

////////////////////////////////////////////////////////////////////////////////
// CopyToClipboard
// 	Copy the current file to the clipboard.
//
procedure TMDIChild.CopyToClipboard;
var
	S: TCBStrings;
begin
	S := TCBStrings.Create;
  try
  	DumpVersionInfo(S);
    S.CopyToClipboard;
  finally
  	S.Free;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
// PasteFromClipboard
// 	Copy the current clipboard contents into the current file.
//
//	Reset Modified, IsExec, VerFileName and Caption.
//
//	In case of failure, kill the current form.
//
procedure TMDIChild.PasteFromClipboard;
var
	S: TCBStrings;
begin
	if IgnoreModifications(TTL_PASTE) then
  begin
    S := TCBStrings.Create;
    try
      try
        S.PasteFromClipboard;
        ParseVersionInfo(FMT_CLIPBOARD, S);
        if (VerFileName <> '') and not IsExec then
        	Caption := Format(FTM_UNTITLED, [Application.MainForm.MDIChildCount + 1]);
        VerFileName := '';
        Modified := False;
        IsExec := False;
      finally
        S.Free;
      end;
  	except
  		NoCloseQuery := True;
  		Close;
      raise;
    end;
	end;
end;

////////////////////////////////////////////////////////////////////////////////
// LoadFromFile
// 	Load the given file.
//	Open a blank form if the file doesn't exist.
//
//	Reset Modified, IsExec, VerFileName and Caption.
//
//	In case of failure, kill the current form.
//
type
	TVS_FIXEDFILEINFO = record
    dwSignature,
    dwStrucVersion,
    dwFileVersionMS,
    dwFileVersionLS,
    dwProductVersionMS,
    dwProductVersionLS,
    dwFileFlagsMask,
    dwFileFlags,
    dwFileOS,
    dwFileType,
    dwFileSubtype,
    dwFileDateMS,
    dwFileDateLS: DWORD;
	end;
  PVS_FIXEDFILEINFO = ^TVS_FIXEDFILEINFO;
  TIntArray = array [0 .. 4095] of Integer;
  PIntArray = ^TIntArray;

procedure TMDIChild.LoadFromFile(const FName: String);

var
	S: TStrings;
  VerData: Pointer;
  VerSize, VerHandle: DWORD;
  FixedInfoPtr: PVS_FIXEDFILEINFO;
  TransInfoPtr: PIntArray;
  MaxTransIndex: Integer;

  { Load version info from an exe file and raise an exception if something }
  { goes wrong. 																													 }
  { Update VerData, FixedInfoPtr, TransInfoPtr, MaxTransIndex 						 }

	procedure LoadFileVersionInfo;
  var
	  numBytes: UINT;
  begin
    if GetFileVersionInfo(PChar(FName), VerHandle, VerSize, VerData) then
      if VerQueryValue(VerData, '\', Pointer(FixedInfoPtr),	numBytes) then
        if VerQueryValue(VerData, '\VarFileInfo\Translation', Pointer(TransInfoPtr), numBytes) then
        begin
        	MaxTransIndex := (numBytes div Sizeof(TLangRec)) - 1;
        	Exit;
        end;
    raise Exception.CreateFmt(MSG_INVALID_FILE, [Format(FMT_TEXT_FILE, [FName])]);
  end;

  { Dump the contents of FixedInfoPtr in the string list S }

  procedure DumpFixedInfo;
  var
  	FVStr, PVStr: String;
    FTypeIndex, FSubTypeIndex, OSIndex, GUIIndex: Integer;
  begin
    with FixedInfoPtr^ do
    begin
    	FVStr := Format('%d,%d,%d,%d', [
      	LongRec(dwFileVersionMS).Hi, LongRec(dwFileVersionMS).Lo,
        LongRec(dwFileVersionLS).Hi, LongRec(dwFileVersionLS).Lo
      ]);

    	PVStr := Format('%d,%d,%d,%d', [
      	LongRec(dwProductVersionMS).Hi, LongRec(dwProductVersionMS).Lo,
        LongRec(dwProductVersionLS).Hi, LongRec(dwProductVersionLS).Lo
      ]);

      FTypeIndex := MapIntArray(dwFileType, MAP_FILETYPE);

      if FTypeIndex = 2 then
      	FSubTypeIndex := MapIntArray(dwFileSubType, MAP_DRVSUBTYPE)
      else if FTypeIndex = 3 then
      	FSubTypeIndex := MapIntArray(dwFileSubType, MAP_FNTSUBTYPE)
      else
        FSubTypeIndex := dwFileSubType;

      OSIndex := MapIntArray(dwFileOS and OS_MASK, MAP_OS);
      GUIIndex := MapIntArray(dwFileOS and GUI_MASK, MAP_GUI);

      S.Add(Format('//%s,%s,$%x,$%x,%d,%d,%d', [
        FVStr, PVStr,	dwFileFlags and dwFileFlagsMask, FTypeIndex, FSubTypeIndex,
        OSIndex, GUIIndex
      ]));
    end;
	end;

  { Dump the contents of TransInfoPtr and the associated StringFileInfo entries }
  { in the string list S.																												}

  procedure DumpTransInfo;
  var
	  numBytes: UINT;
    strInfo: PChar;
    info: TStringInfo;
  	i, j, l, c, x, nbItems: Integer;
    langKey, strName: String;
  begin
    for i := 0 to MaxTransIndex do
    begin

    //-- NOTE: We must swap the words of the TransInfo value

    	with TLangInfo(TransInfoPtr^[i]) do
      begin
      	x := Lang; Lang := CharSet; CharSet := x;
    		langKey := Format('%.4x%.4x', [Lang, CharSet]);
      end;

    //-- Restore only if we know this lang-charset combination

      if IndexToLang(TransInfoPtr^[i], l, c) then
      begin
        nbItems := 0;
        for j := 0 to MAX_STRINGINFO do
        begin
          strName := Format('\StringFileInfo\%s\%s', [langKey, MAP_STRINGINFO[j]]);
          if VerQueryValue(VerData, PChar(strName), Pointer(strInfo), numBytes) then
          begin
            SetString(info[j], strInfo, numBytes);
            Inc(nbItems);
          end else
            info[j] := '';
        end;

        S.Add(Format('//$%s,%d', [langKey, nbItems]));

        for j := 0 to MAX_STRINGINFO do
          if info[j] <> '' then
            S.Add(Format('//%d,"%s"', [j, info[j]]));
      end; // lang OK
    end; // next TransInfoPtr[i]
	end;

  { ** Main block ** 																									  }
  { 	1. If the file doesn't exist then exit 														}
  {		2. Check if the file is an exe with the GetFileVersionInfoSize()  }
  {			 function and update VerSize, VerHandle 												}
  {		3. Dump the binary version information if it is an exe else try   }
  {      a plain text parsing                                           }


begin
	Caption := FName;

	if not FileExists(FName) then	Exit;

  VerFileName := FName;

  try
    S := TStringList.Create;
    try
      VerSize := GetFileVersionInfoSize(PChar(FName), VerHandle);

      if VerSize > 0 then
      begin
        GetMem(VerData, VerSize);
        try
        	LoadFileVersionInfo;

          S.Add(START_MAGIC);

          DumpFixedInfo;
          DumpTransInfo;

          S.Add(END_MAGIC);

        finally
        	FreeMem(VerData, VerSize);
        end;
      end else
      	S.LoadFromFile(FName);

      ParseVersionInfo(Format(FMT_TEXT_FILE, [FName]), S);

      IsExec := VerSize > 0;
      Modified := False;

    finally
      S.Free;
    end;
  except
  	NoCloseQuery := True;
  	Close;
    raise;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
// DumpToFile
// 	Save the current form under the name given by VerFileName.
//	Reset Modified.
//
procedure TMDIChild.DumpToFile;
var
	S: TStrings;
begin
	S := TStringList.Create;
  try
  	DumpVersionInfo(S);
    S.SaveToFile(VerFileName);
    Modified := False;
  finally
  	S.Free;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
// SaveToFile
// 	Save the current form under the name given by VerFileName.
//	If VerFileName is empty or if we loaded the info from an exe file
//	call SaveAsFile instead.
//	Reset Modified.
//
procedure TMDIChild.SaveToFile;
begin
	if (VerFileName = '') or IsExec then
  	SaveAsFile
  else
  	DumpToFile;
end;

////////////////////////////////////////////////////////////////////////////////
// SaveAsFile
// 	Save the current form under a name given by the user.
//	Suggest a name using the Caption property or VerFileName if the current file
//  is an exe.
//
//	Reset Modified, VerFileName, IsExec, Caption.
//
procedure TMDIChild.SaveAsFile;
var
	ext: String;
begin
	with SaveDialog do
  begin
  	if IsExec then
    begin
      ext := ExtractFileExt(VerFileName);
      if ext <> '' then
      	Delete(VerFileName, Pos(ext, VerFileName), Length(ext));
    	IsExec := False;
    end else
      VerFileName := Caption;

  	FileName := VerFileName;
    if Execute then
    	try
      	VerFileName := FileName;
				DumpToFile;
        Caption := VerFileName;
      except
      	VerFileName := '';
      end;
  end;
end;

{* TMDIChild Init/Cleanup *}

////////////////////////////////////////////////////////////////////////////////
// FormCreate
//
procedure TMDIChild.FormCreate(Sender: TObject);
var
	i: Integer;
begin
//-- Load language list
	with ChooseLang do
  	for i := Low(LANGLIST) to High(LANGLIST) do
    	Items.AddObject(LANGLIST[i].s, TObject(LANGLIST[i].v));

//-- Load charset list
	with ChooseCharSet do
  	for i := Low(CHARSETLIST) to High(CHARSETLIST) do
    	Items.AddObject(CHARSETLIST[i].s, TObject(CHARSETLIST[i].v));

//-- Init language things
  Lang := TThings.Create(DestroyInfo);

//-- Force a TabStringInfo.SelLang update
  CurLang := -1;

//-- Set Default page
	PageControl.ActivePage := TabGeneral;

//-- Clear FileName
//	VerFileName := '';

//-- Clear Modification Flag
//	Modified := False;

//-- Not an executable
//	IsExec := False;

//-- Ask before closing
//	NoCloseQuery := False;
end;

////////////////////////////////////////////////////////////////////////////////
// DestroyInfo
//  Call-back method for the "Lang" TThings instance.
//	Free the TStringInfo we store there.
//
procedure TMDIChild.DestroyInfo(Sender: TObject; Thing: Pointer);
begin
	if Assigned(Thing) then
  	Dispose(PStringInfo(Thing));
end;

////////////////////////////////////////////////////////////////////////////////
// FormClose
//
procedure TMDIChild.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	Lang.Free;	// Could be done in FormDestroy
  Action := caFree;
end;

////////////////////////////////////////////////////////////////////////////////
// FormCloseQuery
//	Ask user confirmation if needed before closing the form.
//
procedure TMDIChild.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
	ttl: String;
begin
	CanClose := True;
  if not NoCloseQuery then
  begin
  	ttl := Format(TTL_FMT_CLOSE, [Caption]);
  	if not IgnoreModifications(PChar(ttl)) then
    	CanClose := False;
  end;
end;

{* TMDIChild TabGeneral *}

procedure TMDIChild.FILEFLAGSClick(Sender: TObject);
begin
	with Sender as TCheckBox do
  	if Checked then
  		FFlags := FFlags or MAP_FILEFLAGS[Tag]
    else
    	FFlags := FFlags and (not MAP_FILEFLAGS[Tag]);
  GenericChange(Sender);
end;

{* TMDIChild TabType *}

procedure TMDIChild.FILETYPEClick(Sender: TObject);
var
	enDRV, enFNT, enVXD: Boolean;
begin
	with Sender as TRadioGroup do
  begin
  	enDRV := False;
    enFNT := False;
    enVXD := False;
  	case ItemIndex of
    2: // Device driver
    	enDRV := True;
    3: // Font
    	enFNT := True;
    4: // VXD
    	enVXD := True;
    end;
    if DRV_SUB.Enabled <> enDRV then
    	DRV_SUB.Enabled := enDRV;
    if FNT_SUB.Enabled <> enFNT then
    	FNT_SUB.Enabled := enFNT;
    if VXD_SUB.Enabled <> enVXD then
    	VXD_SUB.Enabled := enVXD;
  end;
  GenericChange(Sender);
end;

{* TMDIChild TabLanguages *}

function TMDIChild.AddLanguage(l, c: Integer): Pointer;
var
  ikey: Integer;
  skey: String;
  info: PStringInfo;
begin
	Result := nil;
	if (l >= 0) and (c >= 0) then
  begin
    TLangInfo(ikey).Lang := LANGLIST[l].v;
    TLangInfo(ikey).CharSet := CHARSETLIST[c].v;
  	if not Lang.IndexExists(ikey) then
    begin
    	New(info);
      Lang.Add(ikey, info);
      skey := Format('%s/%s', [ChooseLang.Items[l], ChooseCharSet.Items[c]]);
      ListLang.Items.AddObject(skey, TObject(ikey));
      SelLang.Items.AddObject(skey, TObject(ikey));
      Result := info;
    end;
  end;
end;

procedure TMDIChild.bAddLangClick(Sender: TObject);
begin
	AddLanguage(ChooseLang.ItemIndex, ChooseCharSet.ItemIndex);
  GenericChange(Sender);
end;

procedure TMDIChild.bRemLangClick(Sender: TObject);
var
	i, index: Integer;
begin
	i := ListLang.ItemIndex;
	if i >= 0 then
  begin
  	index := Integer(ListLang.Items.Objects[i]);
    SelLang.Items.Delete(i);
    SelLangChange(SelLang);
    ListLang.Items.Delete(i);
    Lang.Delete(index);
  end;
  GenericChange(Sender);
end;

{* TMDIChild TabStringInfo *}

procedure TMDIChild.TabStringInfoEnter(Sender: TObject);
var
	i: Integer;
begin
	i := SelLang.ItemIndex;
  if i < 0 then
  begin
  	if SelLang.Text <> '' then
    	SelLang.Text := '';
  	if SelLang.Items.Count > 0 then
    begin
    	SelLang.ItemIndex := 0;
      SelLangChange(SelLang)
    end else
  		ClearStringControls
  end else
  	LoadStringControls(Integer(SelLang.Items.Objects[i]));
end;

procedure TMDIChild.GenericChange(Sender: TObject);
begin
	Modified := True;
end;

procedure TMDIChild.SelLangChange(Sender: TObject);
begin
	TabStringInfoEnter(TabStringInfo);
end;

procedure TMDIChild.StringControlsChange(Sender: TObject);
begin
	with Sender as TEdit do
  	StringInfoStat := StringInfoStat or (1 shl Tag);
end;

procedure TMDIChild.UpdateStringInfo;
var
	i: Integer;
  s: String;
	info: PStringInfo;
begin
	if (CurLang <> 0) and (StringInfoStat <> 0) then
  begin
  	info := Lang.Things[CurLang];
    for i := 0 to MAX_STRINGINFO do
    	if (StringInfoStat and (1 shl i)) <> 0 then
      begin
      	s := (FindComponent(MAP_STRINGINFO[i]) as TEdit).Text;
        if s <> info^[i] then
        begin
      		info^[i] := s;
        	GenericChange(Self);
        end;
      end;
  	StringInfoStat := 0;
  end;
end;

procedure TMDIChild.ClearStringControls;
var
	i: Integer;
begin
	UpdateStringInfo;
	OldLang := CurLang;
  CurLang := 0;
  if CurLang <> OldLang then
    for i := 0 to MAX_STRINGINFO do
      with FindComponent(MAP_STRINGINFO[i]) as TEdit do
      begin
        if Text <> '' then Text := '';
        if Enabled then Enabled := False;
      end;
end;

procedure TMDIChild.LoadStringControls(LangIndex: Integer);
var
	i: Integer;
	info: PStringInfo;
begin
	UpdateStringInfo;
	OldLang := CurLang;
  CurLang := LangIndex;
  if CurLang <> OldLang then
  begin
    info := Lang.Things[LangIndex];
    for i := 0 to MAX_STRINGINFO do
      with FindComponent(MAP_STRINGINFO[i]) as TEdit do
      begin
        if info^[i] <> Text then Text := info^[i];
        if not Enabled then Enabled := True;
      end;
  end;
end;

procedure TMDIChild.PageControlChange(Sender: TObject);
begin
	if PageControl.ActivePage = TabStringInfo then
  	TabStringInfoEnter(TabStringInfo);
end;

end.
